----------------------------------------------------------------------------------
--  
--        counter32.vhd        32 bit JE^[
--  
--        (c)2011/03/23  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
--Selected Device : 3s50avq100-4 
--
-- Number of Slices:                       19  out of    704     2%  
-- Number of Slice Flip Flops:             33  out of   1408     2%  
-- Number of 4 input LUTs:                 37  out of   1408     2%  
-- Number of IOs:                          34
-- Number of bonded IOBs:                  34  out of     68    50%  
-- Number of GCLKs:                         1  out of     24     4%  
-- 
--   Minimum period: 4.486ns (Maximum Frequency: 222.916MHz)
--   Minimum input arrival time before clock: No path found
--   Maximum output required time after clock: 5.642ns
--   Maximum combinational path delay: No path found
--


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;


------------------------------------------------------------------------------
entity counter32 is
  port (
    RESET   : in  std_logic;                      -- 񓯊Zbg
    CLK     : in  std_logic;                      -- clock
    COUNT   : out std_logic_vector(31 downto 0 )  -- JEgl
  );
end counter32;


------------------------------------------------------------------------------
architecture RTL of counter32 is
  
  signal CNT   : std_logic_vector(31 downto 0 );
  signal CARRY : std_logic;                       -- JE^[̓rL[
  
  
begin
  
  COUNT <= CNT;
  
  
  ------------------------------------------------------------------
  --    JE^[    ̂ 16bit ŕăJEg
  ------------------------------------------------------------------
  process( RESET, CLK ) begin
    if(RESET = '1')then
      CNT   <= (others=>'0');
      CARRY <= '0';
    elsif( rising_edge(CLK) )then
      CNT(15 downto 0) <= CNT(15 downto 0) + 1;   -- ƍł邪ALUT gpʑ
      
      if( CNT(15 downto 0) = x"FFFE" )then
        CARRY <= '1';
      else
        CARRY <= '0';
      end if;
      
      if( CARRY = '1' )then
        CNT(31 downto 16) <= CNT(31 downto 16) +1;
      end if;
--      CNT(3 downto 0) <= CNT(3 downto 0) + 1;   -- ƍł邪ALUT gpʑ
--      
--      if( CNT(3 downto 0) = x"E" )then
--        CARRY <= '1';
--      else
--        CARRY <= '0';
--      end if;
--      
--      if( CARRY = '1' )then
--        CNT(31 downto 4) <= CNT(31 downto 4) +1;
--      end if;
    end if;
    
  end process;
  
  
end RTL;
----------------------------- end of architecture ----------------------------
